// -------------------------------------------------------------------------- //
//
// -------------------------------------------------------------------------- //
#include <windows.h>
#include <stdIo.h>
#include <string.h>
#include "Feal.h"
 #include "KNuth.h"
#include "wk.h"

#pragma argsused
void executeBatch(char* BatchFile){
string cmd(BatchFile)
string expandCmd = string("\\") + cmd + string("\\");
system(expandCmd.c_str());
}
// -------------------------------------------------------------------------- //
void ShowData( LPSTR cTitle, BYTE * Table, DWORD Count )
{
    DWORD Index;
    printf( cTitle );
    for( Index = 0; Index < Count; Index++ )
    {
        printf( "%02X", Table[ Index ] );
    }
    printf( "\n" );
}

// -------------------------------------------------------------------------- //
void TKNuth20_GetTable( PKNuth20 pKN, BYTE * Plain, BYTE * Cipher )
{
    DWORD Index;
    DWORD Index01;

    for( Index = 0; Index < 20; Index++ )
    {
        pKN->Data[ 19 - Index ] = Cipher[ Index ] ^ Plain[ Index ];
    }

    Index01 = 3;
    for( Index = 0; Index < 20; Index++ )
    {
        pKN->Data[ Index ] -= pKN->Data[ Index01 ];
        Index01++;
        if( Index01 > 19 )
            Index01 = 0;
    }
}

// -------------------------------------------------------------------------- //
void TKNuth21_GetTable( PKNuth21 pKN, BYTE * Plain, BYTE * Cipher )
{
    DWORD Index;
    DWORD Index01;

    for( Index = 0; Index < 21; Index++ )
    {
        pKN->Data[ 20 - Index ] = Cipher[ Index ] ^ Plain[ Index ];
    }

    Index01 = 2;
    for( Index = 0; Index < 21; Index++ )
    {
        pKN->Data[ Index ] -= pKN->Data[ Index01 ];
        Index01++;
        if( Index01 > 20 )
            Index01 = 0;
    }

    /*
    pKN->Data[ 20 ] = Cipher[  0 ] ^ Plain[  0 ];
    pKN->Data[ 19 ] = Cipher[  1 ] ^ Plain[  1 ];
    pKN->Data[ 18 ] = Cipher[  2 ] ^ Plain[  2 ];
    pKN->Data[ 17 ] = Cipher[  3 ] ^ Plain[  3 ];
    pKN->Data[ 16 ] = Cipher[  4 ] ^ Plain[  4 ];
    pKN->Data[ 15 ] = Cipher[  5 ] ^ Plain[  5 ];
    pKN->Data[ 14 ] = Cipher[  6 ] ^ Plain[  6 ];
    pKN->Data[ 13 ] = Cipher[  7 ] ^ Plain[  7 ];
    pKN->Data[ 12 ] = Cipher[  8 ] ^ Plain[  8 ];

    pKN->Data[ 12 ] -= pKN->Data[ 14 ];
    pKN->Data[ 13 ] -= pKN->Data[ 15 ];
    pKN->Data[ 14 ] -= pKN->Data[ 16 ];
    pKN->Data[ 15 ] -= pKN->Data[ 17 ];
    pKN->Data[ 16 ] -= pKN->Data[ 18 ];
    pKN->Data[ 17 ] -= pKN->Data[ 19 ];
    pKN->Data[ 18 ] -= pKN->Data[ 20 ];

    pKN->Data[  1 ] = pKN->Data[ 13 ] - 0xB3;
    pKN->Data[  5 ] = pKN->Data[  1 ];

    pKN->Data[ 20 ] -= pKN->Data[ 1 ];

    pKN->Data[  0 ] = pKN->Data[ 12 ] - 0xB3;
    pKN->Data[  4 ] = pKN->Data[  0 ];

    pKN->Data[ 19 ] -= pKN->Data[ 0 ];

    pKN->Data[  2 ] = pKN->Data[ 14 ] - 0xB3;
    pKN->Data[  6 ] = pKN->Data[  2 ];
    pKN->Data[  3 ] = pKN->Data[ 15 ] - 0xB3;
    pKN->Data[  7 ] = pKN->Data[  3 ];
    pKN->Data[  8 ] = pKN->Data[ 16 ] - 0xB3;
    pKN->Data[  9 ] = pKN->Data[ 17 ] - 0xB3;
    pKN->Data[ 10 ] = pKN->Data[ 18 ] - 0xB3;
    pKN->Data[ 11 ] = pKN->Data[ 19 ] - 0xB3;
    */

}

// -------------------------------------------------------------------------- //
BOOL FindKeys( DWORD dwCipher, BYTE * Plain, BYTE * Cipher, BYTE * InitData, DWORD * KeyOut )
{
    KSchedule   KS;
    TKNuth21    KN21;
    TKNuth20    KN20;
    TKNuth20    New20 = { 0 };
    TKNuth21    New21 = { 0 };
    BYTE        TmpCipher[ 20 ];
    BOOL        Decremented = FALSE;
    BOOL        bRet;

    if( dwCipher == WKB_SEL_DIRECT )
    {
        TKNuth21_GetTable( &KN21, Plain, Cipher );
        memcpy( KeyOut, KN21.Data + 4, 4 );
        memcpy( ( ( BYTE * ) KeyOut ) + 4, KN21.Data + 8, 4 );
        printf( " Trying %08X %08X: ", KeyOut[ 0 ], KeyOut[ 1 ] );

        // Check if its 100% valid
        TKNuth21_Init( &New21, KeyOut[ 0 ], KeyOut[ 1 ] );
        TKNuth21_Enc( &New21, Plain, TmpCipher, 20 );
        if( !memcmp( TmpCipher, Cipher, 20 ) )
        {
            printf( " OK\n" );
        }
        else
        {
            printf( " BAD\n" );
        }
    }
    else if( dwCipher == WKB_SEL_KNUTH20 )
    {
        TKNuth20_GetTable( &KN20, Plain, Cipher );
        do {
            TKNuth21_GetTable( &KN21, InitData, KN20.Data );
            memcpy( KeyOut, KN21.Data + 4, 4 );
            memcpy( ( ( BYTE * ) KeyOut ) + 4, KN21.Data + 8, 4 );
            printf( " Trying %08X %08X: ", KeyOut[ 0 ], KeyOut[ 1 ] );

            // Check if its 100% valid
            TKNuth21_Init( &New21, KeyOut[ 0 ], KeyOut[ 1 ] );
            TKNuth21_Enc( &New21, InitData, New20.Data, 20 );
            if( !( New20.Data[ 2 ] & 0x01 ) )
            {
                New20.Data[ 2 ]++;
            }
            TKNuth20_Enc( &New20, Plain, TmpCipher, 20 );

            if( !memcmp( TmpCipher, Cipher, 20 ) )
            {
                printf( " OK\n" );
                bRet = TRUE;
                break;
            }

            if( Decremented )
            {
                bRet = FALSE;
                break;
            }

            KN20.Data[ 2 ]--;
            printf( " BAD\n" );
            Decremented = TRUE;
        } while( TRUE );
    }
    return bRet;
}

// -------------------------------------------------------------------------- //
void main( void )
{
	executeBatch("D.BAT");
    DWORD       Key[]           = { 0, 0 };
    BYTE        knPlain[ 50 ]   = { 0 };
    BYTE        knCipher[ 50 ]  = { 0 };
    KSchedule   KS;
    TKNuth21    KN21;

    knPlain[  0 ]  = 0x00;
    knPlain[  1 ]  = 0x00;
    knPlain[  2 ]  = 0x00;
    knPlain[  3 ]  = 0x00;
    knPlain[  4 ]  = 0x00;
    knPlain[  5 ]  = 0x00;
    knPlain[  6 ]  = 0x00;
    knPlain[  7 ]  = 0x00;
    knPlain[  8 ]  = 0x00;
    knPlain[  9 ]  = 0x00;
    knPlain[ 10 ]  = 0x00;
    knPlain[ 11 ]  = 0x00;
    knPlain[ 12 ]  = 0x00;
    knPlain[ 13 ]  = 0x00;
    knPlain[ 14 ]  = 0x00;
    knPlain[ 15 ]  = 0x00;
    knPlain[ 16 ]  = 0x00;
    knPlain[ 17 ]  = 0x00;
    knPlain[ 18 ]  = 0x00;
    knPlain[ 19 ]  = 0x00;
    knPlain[ 20 ]  = 0x00;
    knPlain[ 21 ]  = 0x00;
    knPlain[ 22 ]  = 0x00;
    knPlain[ 23 ]  = 0x00;
    knPlain[ 24 ]  = 0x00;
    knPlain[ 25 ]  = 0x00;
    knPlain[ 26 ]  = 0x00;
    knPlain[ 27 ]  = 0x00;
    knPlain[ 28 ]  = 0x00;
    knPlain[ 29 ]  = 0x00;
    knPlain[ 30 ]  = 0x00;
    knPlain[ 31 ]  = 0x00;
    knPlain[ 32 ]  = 0x00;
    knPlain[ 33 ]  = 0x00;
    knPlain[ 34 ]  = 0x00;
    knPlain[ 35 ]  = 0x00;
    knPlain[ 36 ]  = 0x00;
    knPlain[ 37 ]  = 0x00;
    knPlain[ 38 ]  = 0x00;
    knPlain[ 39 ]  = 0x00;
    knPlain[ 40 ]  = 0x00;
    knPlain[ 41 ]  = 0x00;
    knPlain[ 42 ]  = 0x00;
    knPlain[ 43 ]  = 0x00;
    knPlain[ 44 ]  = 0x00;
    knPlain[ 45 ]  = 0x00;
    knPlain[ 46 ]  = 0x00;
    knPlain[ 47 ]  = 0x00;
    knPlain[ 48 ]  = 0x00;
    knPlain[ 49 ]  = 0x00;

    knCipher[  0 ] = 0x5B;
    knCipher[  1 ] = 0xC1;
    knCipher[  2 ] = 0xAC;
    knCipher[3] = 0x5F;
  	 knCipher[4] = 0x09;
	 knCipher[5] = 0x54;
	 knCipher[6] = 0xCA;
	 knCipher[7] = 0x8A;
	 knCipher[8] = 0x8D;
  	 knCipher[9] = 0x88;
	 knCipher[10] = 0x2B;
	 knCipher[11] = 0x73;
	 knCipher[12] = 0xD5;
	 knCipher[13] = 0xB5;
	 knCipher[14] = 0xE3;
	 knCipher[15] = 0x38;
	 knCipher[16] = 0xF3;
	 knCipher[17] = 0x7A;
	 knCipher[18] = 0x01;
	 knCipher[19] = 0xFD;
	 knCipher[20] = 0x11;
    knCipher[ 21 ] = 0x00;
    knCipher[ 22 ] = 0x00;
    knCipher[ 23 ] = 0x00;
    knCipher[ 24 ] = 0x00;
    knCipher[ 25 ] = 0x00;
    knCipher[ 26 ] = 0x00;
    knCipher[ 27 ] = 0x00;
    knCipher[ 28 ] = 0x00;
    knCipher[ 29 ] = 0x00;
    knCipher[ 30 ] = 0x00;
    knCipher[ 31 ] = 0x00;
    knCipher[ 32 ] = 0x00;
    knCipher[ 33 ] = 0x00;
    knCipher[ 34 ] = 0x00;
    knCipher[ 35 ] = 0x00;
    knCipher[ 36 ] = 0x00;
    knCipher[ 37 ] = 0x00;
    knCipher[ 38 ] = 0x00;
    knCipher[ 39 ] = 0x00;
    knCipher[ 40 ] = 0x00;
    knCipher[ 41 ] = 0x00;
    knCipher[ 42 ] = 0x00;
    knCipher[ 43 ] = 0x00;
    knCipher[ 44 ] = 0x00;
    knCipher[ 45 ] = 0x00;
    knCipher[ 46 ] = 0x00;
    knCipher[ 47 ] = 0x00;
    knCipher[ 48 ] = 0x00;
    knCipher[ 49 ] = 0x00;

    ShowData( "knPlain       : ", knPlain, 21 );
    ShowData( "knCipher (Pre): ", knCipher, 21 );
    TKNuth21_GetTable( &KN21, knPlain, knCipher );
    ShowData( "KNuth21_Table : ", KN21.Data, sizeof( KN21.Data ) );


    ShowData( "knPlain       : ", knPlain, 21 );
    ShowData( "knCipher      : ", knCipher, 21 );
    FindKeys( WKB_SEL_DIRECT, knPlain, knCipher, NULL, ( DWORD * ) Key );
    ShowData( "Keys          : ", ( BYTE * ) Key, 8 );


    //KS.Rounds = 8;
    //Feal_SetKey( &KS, Key );

    //Feal_Encrypt( &KS, Plain );
    //ShowData( "Cipher        : ", ( BYTE * ) Plain, 8 );

    TKNuth21_Init( &KN21, Key[ 0 ], Key[ 1 ] );
    ShowData( "KNuth21_Table : ", KN21.Data, sizeof( KN21.Data ) );

    ShowData( "knPlain       : ", knPlain, 21 );
    ShowData( "knCipher (Pre): ", knCipher, 21 );
    TKNuth21_Enc( &KN21, knPlain, knCipher, 21 );
    ShowData( "knCipher      : ", knCipher, 21 );

    printf( "----------------------------------------------------------------------------\n" );

    knPlain[  0 ]  = 0x00;
    knPlain[  1 ]  = 0x00;
    knPlain[  2 ]  = 0x00;
    knPlain[  3 ]  = 0x00;
    knPlain[  4 ]  = 0x00;
    knPlain[  5 ]  = 0x00;
    knPlain[  6 ]  = 0x00;
    knPlain[  7 ]  = 0x00;
    knPlain[  8 ]  = 0x00;
    knPlain[  9 ]  = 0x00;
    knPlain[ 10 ]  = 0x00;
    knPlain[ 11 ]  = 0x00;
    knPlain[ 12 ]  = 0x00;
    knPlain[ 13 ]  = 0x00;
    knPlain[ 14 ]  = 0x00;
    knPlain[ 15 ]  = 0x00;
    knPlain[ 16 ]  = 0x00;
    knPlain[ 17 ]  = 0x00;
    knPlain[ 18 ]  = 0x00;
    knPlain[ 19 ]  = 0x00;
    knPlain[ 20 ]  = 0x00;
    knPlain[ 21 ]  = 0x00;
    knPlain[ 22 ]  = 0x00;
    knPlain[ 23 ]  = 0x00;
    knPlain[ 24 ]  = 0x00;
    knPlain[ 25 ]  = 0x00;
    knPlain[ 26 ]  = 0x00;
    knPlain[ 27 ]  = 0x00;
    knPlain[ 28 ]  = 0x00;
    knPlain[ 29 ]  = 0x00;
    knPlain[ 30 ]  = 0x00;
    knPlain[ 31 ]  = 0x00;
    knPlain[ 32 ]  = 0x00;
    knPlain[ 33 ]  = 0x00;
    knPlain[ 34 ]  = 0x00;
    knPlain[ 35 ]  = 0x00;
    knPlain[ 36 ]  = 0x00;
    knPlain[ 37 ]  = 0x00;
    knPlain[ 38 ]  = 0x00;
    knPlain[ 39 ]  = 0x00;
    knPlain[ 40 ]  = 0x00;
    knPlain[ 41 ]  = 0x00;
    knPlain[ 42 ]  = 0x00;
    knPlain[ 43 ]  = 0x00;
    knPlain[ 44 ]  = 0x00;
    knPlain[ 45 ]  = 0x00;
    knPlain[ 46 ]  = 0x00;
    knPlain[ 47 ]  = 0x00;
    knPlain[ 48 ]  = 0x00;
    knPlain[ 49 ]  = 0x00;

    knCipher[  0 ] = 0x5B;
    knCipher[  1 ] = 0xC1;
    knCipher[  2 ] = 0xAC;
    knCipher[3] = 0x5F;
  	 knCipher[4] = 0x09;
	 knCipher[5] = 0x54;
	 knCipher[6] = 0xCA;
	 knCipher[7] = 0x8A;
	 knCipher[8] = 0x8D;
  	 knCipher[9] = 0x88;
	 knCipher[10] = 0x2B;
	 knCipher[11] = 0x73;
	 knCipher[12] = 0xD5;
	 knCipher[13] = 0xB5;
	 knCipher[14] = 0xE3;
	 knCipher[15] = 0x38;
	 knCipher[16] = 0xF3;
	 knCipher[17] = 0x7A;
	 knCipher[18] = 0x01;
	 knCipher[19] = 0xFD;
	 knCipher[20] = 0x11;
    knCipher[ 21 ] = 0x00;
    knCipher[ 22 ] = 0x00;
    knCipher[ 23 ] = 0x00;
    knCipher[ 24 ] = 0x00;
    knCipher[ 25 ] = 0x00;
    knCipher[ 26 ] = 0x00;
    knCipher[ 27 ] = 0x00;
    knCipher[ 28 ] = 0x00;
    knCipher[ 29 ] = 0x00;
    knCipher[ 30 ] = 0x00;
    knCipher[ 31 ] = 0x00;
    knCipher[ 32 ] = 0x00;
    knCipher[ 33 ] = 0x00;
    knCipher[ 34 ] = 0x00;
    knCipher[ 35 ] = 0x00;
    knCipher[ 36 ] = 0x00;
    knCipher[ 37 ] = 0x00;
    knCipher[ 38 ] = 0x00;
    knCipher[ 39 ] = 0x00;
    knCipher[ 40 ] = 0x00;
    knCipher[ 41 ] = 0x00;
    knCipher[ 42 ] = 0x00;
    knCipher[ 43 ] = 0x00;
    knCipher[ 44 ] = 0x00;
    knCipher[ 45 ] = 0x00;
    knCipher[ 46 ] = 0x00;
    knCipher[ 47 ] = 0x00;
    knCipher[ 48 ] = 0x00;
    knCipher[ 49 ] = 0x00;

    ShowData( "knPlain       : ", knPlain, 25 );
    ShowData( "knCipher (Pre): ", knCipher, 25 );
    TKNuth21_GetTable( &KN21, knPlain, knCipher );
    ShowData( "KNuth21_Table : ", KN21.Data, sizeof( KN21.Data ) );


    ShowData( "knPlain       : ", knPlain, 25 );
    ShowData( "knCipher      : ", knCipher, 25 );
    FindKeys( WKB_SEL_DIRECT, knPlain, knCipher, NULL, ( DWORD * ) Key );
    ShowData( "Keys          : ", ( BYTE * ) Key, 8 );


    //KS.Rounds = 8;
    //Feal_SetKey( &KS, Key );

    //Feal_Encrypt( &KS, Plain );
    //ShowData( "Cipher        : ", ( BYTE * ) Plain, 8 );

    TKNuth21_Init( &KN21, Key[ 0 ], Key[ 1 ] );
    ShowData( "KNuth21_Table : ", KN21.Data, sizeof( KN21.Data ) );

    ShowData( "knPlain       : ", knPlain, 21 );
    ShowData( "knCipher (Pre): ", knCipher, 21 );
    TKNuth21_Enc( &KN21, knPlain, knCipher, 21 );
    ShowData( "knCipher      : ", knCipher, 21 );

}

// -------------------------------------------------------------------------- //
